;;;
;;; QTC-B12: Qualitative Trajectory Calculus Basic 1D Level 2 with 17 base relations
;;;

(def-calculus "QTC-B12: Qualitative Trajectory Calculus Basic 1D Level 2 with 17 base relations"
  :arity :binary
  ;;:qualifier (external-lib "libqtc.dylib" "qualify_qtc_b12")
  :basis-entity :dipole ;; 1D point resp. 1D interval + additional velocity
  :identity-relation 000
  :converse-operation ( ( --- --+ )
			( -+- +-+ )
			( 0-- -0+ )
			( 0+- +0+ )
			( +-- -++ )
			( ++- +++ )
			( --0 --0 )
			( -+0 +-0 )
			( 000 000 )
			( +-0 -+0 )
			( ++0 ++0 )
			( --+ --- ) 
			( -0+ 0-- )
			( -++ +-- ) 
			( +-+ -+- )
			( +0+ 0+- ) 
			( +++ ++- )
		      )
  
  :base-relations (---     -+- 0--     0+- +--     ++-
		   --0     -+0     000     +-0     ++0
		   --+ -0+ -++             +-+ +0+ +++)
  ;; -0- 00- +0- -00 0-0 0+0 +00 0-+ 00+ 0++ are physically not possible

  :composition-operation ( ;; 1st row
			  (--- --- ( -+- +-- ))
			  (--- -+- ( --- ++- )) 
			  (--- 0-- ( )) 
			  (--- 0+- ( )) 
			  (--- +-- ( --- )) 
			  (--- ++- ( -+- )) 
			  (--- --0 ( -+- +-- ))
			  (--- -+0 ( --- ++- )) 
			  (--- 000 ( )) 
			  (--- +-0 ( --- )) 
			  (--- ++0 ( -+- )) 
			  (--- --+ ( -+- +-- -+0 +-0 -++ +-+ ))
			  (--- -0+ (  -0+ +0+ )) 
			  (--- -++ ( --- ++- --0 ++0 --+ +++ )) 
			  (--- +-+ ( --- --0 --+ )) 
			  (--- +0+ ( -0+ )) 
			  (--- +++ ( -+- -+0 -++ )) 

			  (-+- --- ( --- )) 
			  (-+- -+- ( -+- )) 
			  (-+- 0-- ( )) 
			  (-+- 0+- ( )) 
			  (-+- +-- ( -+- +-- )) 
			  (-+- ++- ( --- ++- )) 
			  (-+- --0 ( --- )) 
			  (-+- -+0 ( -+- )) 
			  (-+- 000 ( )) 
			  (-+- +-0 ( -+- +-- )) 
			  (-+- ++0 ( --- ++- )) 
			  (-+- --+ ( --- --0 --+ )) 
			  (-+- -0+ ( -0+ )) 
			  (-+- -++ ( -+- -+0 -++ )) 
			  (-+- +-+ ( -+- +-- -+0 +-0 -++ +-+ )) 
			  (-+- +0+ (  -0+ +0+ )) 
			  (-+- +++ ( --- ++- --0 ++0 --+ +++ )) 

			  (0-- --- ( 0-- 0+- )) 
			  (0-- -+- ( 0-- 0+- )) 
			  (0-- 0-- ( )) 
			  (0-- 0+- ( )) 
			  (0-- +-- ( 0-- )) 
			  (0-- ++- ( 0+- )) 
			  (0-- --0 ( 0-- 0+- )) 
			  (0-- -+0 ( 0-- 0+- )) 
			  (0-- 000 ( )) 
			  (0-- +-0 ( 0-- )) 
			  (0-- ++0 ( 0+- )) 
			  (0-- --+ ( 0-- 0+- )) 
			  (0-- -0+ ( 000 )) 
			  (0-- -++ ( 0-- 0+-     )) 
			  (0-- +-+ ( 0-- )) 
			  (0-- +0+ ( 000 )) 
			  (0-- +++ ( 0+-  )) 

			  (0+- --- ( 0-- )) 
			  (0+- -+- ( 0+- )) 
			  (0+- 0-- ( )) 
			  (0+- 0+- ( )) 
			  (0+- +-- ( 0-- 0+- )) 
			  (0+- ++- ( 0-- 0+-)) 
			  (0+- --0 ( 0-- )) 
			  (0+- -+0 ( 0+- )) 
			  (0+- 000 ( )) 
			  (0+- +-0 ( 0-- 0+- )) 
			  (0+- ++0 ( 0-- 0+-)) 
			  (0+- --+ ( 0-- )) 
			  (0+- -0+ ( 000 )) 
			  (0+- -++ ( 0+- )) 
			  (0+- +-+ ( 0-- 0+- )) 
			  (0+- +0+ ( 000  )) 
			  (0+- +++ ( 0-- 0+- )) 

			  (+-- --- ( --- ++- )) 
			  (+-- -+- ( -+- +-- )) 
			  (+-- 0-- ( )) 
			  (+-- 0+- ( )) 
			  (+-- +-- ( +-- )) 
			  (+-- ++- ( ++- )) 
			  (+-- --0 ( --- ++- )) 
			  (+-- -+0 ( -+- +-- )) 
			  (+-- 000 ( )) 
			  (+-- +-0 ( +-- )) 
			  (+-- ++0 ( ++- )) 
			  (+-- --+ ( --- ++- --0 ++0 --+ +++ )) 
			  (+-- -0+ (  -0+ +0+ )) 
			  (+-- -++ ( -+- +-- -+0 +-0 -++ +-+ )) 
			  (+-- +-+ ( +-- +-0 +-+ )) 
			  (+-- +0+ (  +0+ )) 
			  (+-- +++ ( ++- ++0 +++ )) 

			  (++- --- ( +-- )) 
			  (++- -+- ( ++- )) 
			  (++- 0-- ( )) 
			  (++- 0+- ( )) 
			  (++- +-- ( --- ++- )) 
			  (++- ++- ( -+- +-- )) 
			  (++- --0 ( +-- )) 
			  (++- -+0 ( ++- )) 
			  (++- 000 ( )) 
			  (++- +-0 ( --- ++- )) 
			  (++- ++0 ( -+- +-- )) 
			  (++- --+ ( +-- +-0 +-+ )) 
			  (++- -0+ (  +0+ )) 
			  (++- -++ ( ++- ++0 +++ )) 
			  (++- +-+ ( --- ++- --0 ++0 --+ +++ )) 
			  (++- +0+ (  -0+ +0+ )) 
			  (++- +++ ( -+- +-- -+0 +-0 -++ +-+ )) 


			  ;; 2nd row
			  (--0 --- ( -+- +-- ))
			  (--0 -+- ( --- ++- )) 
			  (--0 0-- ( )) 
			  (--0 0+- ( )) 
			  (--0 +-- ( --- )) 
			  (--0 ++- ( -+- )) 
			  (--0 --0 ( -+0 +-0 ))
			  (--0 -+0 ( --0 ++0 )) 
			  (--0 000 ( )) 
			  (--0 +-0 ( --0 )) 
			  (--0 ++0 ( -+0 )) 
			  (--0 --+ ( -++ +-+ ))
			  (--0 -0+ ( -0+ +0+ )) 
			  (--0 -++ ( --+ +++ )) 
			  (--0 +-+ ( --+ )) 
			  (--0 +0+ ( -0+ )) 
			  (--0 +++ ( -++ )) 

			  (-+0 --- ( --- )) 
			  (-+0 -+- ( -+- )) 
			  (-+0 0-- ( )) 
			  (-+0 0+- ( )) 
			  (-+0 +-- ( -+- +-- )) 
			  (-+0 ++- ( --- ++- )) 
			  (-+0 --0 ( --- )) 
			  (-+0 -+0 ( -+- )) 
			  (-+0 000 ( )) 
			  (-+0 +-0 ( -+0 +-0 )) 
			  (-+0 ++0 ( --0 ++0 )) 
			  (-+0 --+ ( --+ )) 
			  (-+0 -0+ ( -0+ )) 
			  (-+0 -++ ( -++ )) 
			  (-+0 +-+ ( -++ +-+ )) 
			  (-+0 +0+ ( -0+ +0+ )) 
			  (-+0 +++ ( --+ +++ )) 

			  (000 --- ( )) 
			  (000 -+- ( )) 
			  (000 0-- ( 0-- 0+- )) 
			  (000 0+- ( 0-- 0+- )) 
			  (000 +-- ( )) 
			  (000 ++- ( )) 
			  (000 --0 ( )) 
			  (000 -+0 ( )) 
			  (000 000 ( 000 )) 
			  (000 +-0 ( )) 
			  (000 ++0 ( )) 
			  (000 --+ ( )) 
			  (000 -0+ ( )) 
			  (000 -++ ( )) 
			  (000 +-+ ( )) 
			  (000 +0+ ( )) 
			  (000 +++ ( )) 

			  (+-0 --- ( --- ++- )) 
			  (+-0 -+- ( -+- +-- )) 
			  (+-0 0-- ( )) 
			  (+-0 0+- ( )) 
			  (+-0 +-- ( +-- )) 
			  (+-0 ++- ( ++- )) 
			  (+-0 --0 ( --0 ++0 )) 
			  (+-0 -+0 ( -+0 +-0 )) 
			  (+-0 000 ( )) 
			  (+-0 +-0 ( +-0 )) 
			  (+-0 ++0 ( ++0 )) 
			  (+-0 --+ ( --+ +++ )) 
			  (+-0 -0+ ( -0+ +0+ )) 
			  (+-0 -++ ( -++ +-+ )) 
			  (+-0 +-+ ( +-+ )) 
			  (+-0 +0+ ( +0+ )) 
			  (+-0 +++ ( +++ )) 


			  (++0 --- ( +-- )) 
			  (++0 -+- ( ++- )) 
			  (++0 0-- ( )) 
			  (++0 0+- ( )) 
			  (++0 +-- ( --- ++- )) 
			  (++0 ++- ( -+- +-- )) 
			  (++0 --0 ( +-0 )) 
			  (++0 -+0 ( ++0 )) 
			  (++0 000 ( )) 
			  (++0 +-0 ( --0 ++0 )) 
			  (++0 ++0 ( -+0 +-0 )) 
			  (++0 --+ ( +-+ )) 
			  (++0 -0+ ( +0+ )) 
			  (++0 -++ ( +++ )) 
			  (++0 +-+ ( --+ +++ )) 
			  (++0 +0+ ( -0+ +0+ )) 
			  (++0 +++ ( -++ +-+ )) 

			  ;; 3rd row
			  (--+ --- ( -+- +-- -+0 +-0 -++ +-+ ))
			  (--+ -+- ( --- ++- --0 ++0 --+ +++ )) 
			  (--+ 0-- ( )) 
			  (--+ 0+- ( )) 
			  (--+ +-- ( --- --0 --+ )) 
			  (--+ ++- ( -+- -+0 -++ )) 
			  (--+ --0 ( -++ +-+ ))
			  (--+ -+0 ( --+ +++ )) 
			  (--+ 000 ( )) 
			  (--+ +-0 ( --+ )) 
			  (--+ ++0 ( -++ )) 
			  (--+ --+ ( -++ +-+ ))
			  (--+ -0+ ( -0+ +0+ )) 
			  (--+ -++ ( --+ +++ )) 
			  (--+ +-+ ( --+ )) 
			  (--+ +0+ ( -0+ )) 
			  (--+ +++ ( -++ )) 

			  (-0+ --- ( )) 
			  (-0+ -+- ( )) 
			  (-0+ 0-- ( --- -+- +-- --0 -+0 +-0 --+ -++ +-+ )) 
			  (-0+ 0+- ( --- -+- ++- --0 -+0 ++0 --+ -++ +++ )) 
			  (-0+ +-- ( )) 
			  (-0+ ++- ( )) 
			  (-0+ --0 ( )) 
			  (-0+ -+0 ( )) 
			  (-0+ 000 ( -0+ +0+ )) 
			  (-0+ +-0 ( )) 
			  (-0+ ++0 ( )) 
			  (-0+ --+ ( )) 
			  (-0+ -0+ ( )) 
			  (-0+ -++ ( )) 
			  (-0+ +-+ ( )) 
			  (-0+ +0+ ( )) 
			  (-0+ +++ ( )) 

			  (-++ --- ( --- --0 --+ )) 
			  (-++ -+- ( -+- -+0 -++ )) 
			  (-++ 0-- ( )) 
			  (-++ 0+- ( )) 
			  (-++ +-- ( -+- +-- -+0 +-0 -++ +-+ )) 
			  (-++ ++- ( --- ++- --0 ++0 --+ +++ )) 
			  (-++ --0 ( --+ )) 
			  (-++ -+0 ( -++ )) 
			  (-++ 000 ( )) 
			  (-++ +-0 ( -++ +-+ )) 
			  (-++ ++0 ( --+ +++ )) 
			  (-++ --+ ( --+ )) 
			  (-++ -0+ ( -0+ )) 
			  (-++ -++ ( -++ )) 
			  (-++ +-+ ( -++ +-+ )) 
			  (-++ +0+ ( -0+ +0+ )) 
			  (-++ +++ ( --+ +++ )) 

			  (+-+ --- ( --- ++- --0 ++0 --+ +++ )) 
			  (+-+ -+- ( -+- +-- -+0 +-0 -++ +-+ )) 
			  (+-+ 0-- ( )) 
			  (+-+ 0+- ( )) 
			  (+-+ +-- ( +-- +-0 +-+ )) 
			  (+-+ ++- ( ++- ++0 +++ )) 
			  (+-+ --0 ( --+ +++ )) 
			  (+-+ -+0 ( -++ +-+ )) 
			  (+-+ 000 ( )) 
			  (+-+ +-0 ( +-+ )) 
			  (+-+ ++0 ( +++ )) 
			  (+-+ --+ ( --+ +++ )) 
			  (+-+ -0+ ( -0+ +0+ )) 
			  (+-+ -++ ( -++ +-+ )) 
			  (+-+ +-+ ( +-+ )) 
			  (+-+ +0+ ( +0+ )) 
			  (+-+ +++ ( +++ )) 

			  (+0+ --- ( )) 
			  (+0+ -+- ( )) 
			  (+0+ 0-- ( --- +-- ++- --0 +-0 ++0 --+ +-+ +++ )) 
			  (+0+ 0+- ( -+- +-- ++- -+0 +-0 ++0 -++ +-+ +++ )) 
			  (+0+ +-- ( )) 
			  (+0+ ++- ( )) 
			  (+0+ --0 ( )) 
			  (+0+ -+0 ( )) 
			  (+0+ 000 ( +0+ -0+ )) 
			  (+0+ +-0 ( )) 
			  (+0+ ++0 ( )) 
			  (+0+ --+ ( )) 
			  (+0+ -0+ ( )) 
			  (+0+ -++ ( )) 
			  (+0+ +-+ ( )) 
			  (+0+ +0+ ( )) 
			  (+0+ +++ ( )) 

			  (+++ --- ( +-- +-0 +-+ )) 
			  (+++ -+- ( ++- ++0 +++ )) 
			  (+++ 0-- ( )) 
			  (+++ 0+- ( )) 
			  (+++ +-- ( --- ++- --0 ++0 --+ +++ )) 
			  (+++ ++- ( -+- +-- -+0 +-0 -++ +-+ )) 
			  (+++ --0 ( +-+ )) 
			  (+++ -+0 ( +++ )) 
			  (+++ 000 ( )) 
			  (+++ +-0 ( --+ +++ )) 
			  (+++ ++0 ( -++ +-+ )) 
			  (+++ --+ ( +-+ )) 
			  (+++ -0+ ( +0+ )) 
			  (+++ -++ ( +++ )) 
			  (+++ +-+ ( --+ +++ )) 
			  (+++ +0+ ( -0+ +0+ )) 
			  (+++ +++ ( -++ +-+ )) 
			  
			  )
  )


